SimpleMp3PlayListTemp = {}
------------------------------------------------------
-- Playlist Functions
------------------------------------------------------

function PLInfo(x, num)
    if (Smp3_Save.SimpleMp3PlayList[1]) then
        if (x == 'song') then
            if (Smp3_Save.SimpleMp3PlayList[num].Title == 'None') then
                return string.gsub(Smp3_Save.SimpleMp3PlayList[num].Name, "^.+\\", "");
            else
                return Smp3_Save.SimpleMp3PlayList[num].Title;
            end
        elseif (x == 'artist') then
            if (Smp3_Save.SimpleMp3PlayList[num].Artist == 'None') then
                return SIMPLEMP3_UNK_ARTIST;
            else
                return Smp3_Save.SimpleMp3PlayList[num].Artist;
            end
        elseif (x == 'album') then
            if (Smp3_Save.SimpleMp3PlayList[num].Album == 'None') then
                return SIMPLEMP3_UNK_ALBUM;
            else
                return Smp3_Save.SimpleMp3PlayList[num].Album;
            end
        elseif (x == 'genre') then
            if (Smp3_Save.SimpleMp3PlayList[num].Genre == 'None') then
                return SIMPLEMP3_UNK_GENRE;
            else
                return Smp3_Save.SimpleMp3PlayList[num].Genre;
            end
        elseif (x == 'bitrate') then
            if (Smp3_Save.SimpleMp3PlayList[num].BitRate == 'None') then
                return SIMPLEMP3_UNK_BITRATE;
            else
                return Smp3_Save.SimpleMp3PlayList[num].BitRate;
            end
        elseif (x == 'name') then
            return Smp3_Save.SimpleMp3PlayList[num].Name;
        elseif (x == 'name2') then
            return string.gsub(Smp3_Save.SimpleMp3PlayList[num].Name, "^.+\\", "");
        elseif (x == 'length') then
            return Smp3_Save.SimpleMp3PlayList[num].Length;
        elseif (x == 'length2') then
            return Time(Smp3_Save.SimpleMp3PlayList[num].Length);
        end
    else
        return SIMPLEMP3_UNK
    end
end

function PlayListDisplay(num)
    if (Smp3_Save.UseTags == true) then
        return PLInfo('song', num) .. " " .. "|cFFFFFFFF" .. PLInfo('artist', num) .. " " .. "|r" .. PLInfo('album', num) .. " ".. "|cFFFFFFFF"  .. PLInfo('genre', num) .. " " .. "|r" .. PLInfo('bitrate', num) .. "k " .. "|cFFFFFFFF" .. PLInfo('length2', num) .. "|r";
    else
        return PLInfo('name2', num) .. " " .. PLInfo('length2', num);
    end
end

-- Playlist Onshow tells it to update
function SimpleMp3Playlist_OnShow()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoOpen");
    end
    Smp3_Save.wasVisiblePL = true;
    SimpleMp3Playlist_Update()
end

function SimpleMp3Playlist_OnHide()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoClose");
    end
    Smp3_Save.wasVisiblePL = false;
end

 -- When the scrollbar is changed so shall the list
function SimpleMp3Playlist_OnValueChanged()
    SimpleMp3Playlist_Update()
end
-- First load to set total population for the slider
function SimpleMp3Playlist_OnLoad()
    local SliderVar;
    this:RegisterForDrag("LeftButton");
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistSlider");
        if (Smp3_Save.SimpleMp3PlayList[1]) then
        SliderVar:SetMinMaxValues(1, SliderMax(table.getn(Smp3_Save.SimpleMp3PlayList), Smp3_Save.VisibleSlots));
    end
    SimpleMp3Playlist_Update()
end

function SimpleMp3Playlist_OnEvent()
end

-- Playlist form populates the list according to window size
function PopulateList()
    local LabelVar, SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistSlider");
    MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);

    if (MaxPlayListNum == 1) then
        LabelVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistPanel" .. 1);
        LabelVar:SetText(SliderVar:GetValue() + 0 .. ". " .. PlayListDisplay(SliderVar:GetValue() + 0));
   elseif (Smp3_Save.VisibleSlots <= MaxPlayListNum) then
        for i=1,Smp3_Save.VisibleSlots do
            LabelVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistPanel" .. i);
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. PlayListDisplay(SliderVar:GetValue() + (i - 1)));
        end
    else
        for i=1,MaxPlayListNum do
            LabelVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistPanel" .. i);

            if (i > MaxPlayListNum) then
                return;
            end

            -- Debugging purposes while fixing playlist resizing issue
            -- DEFAULT_CHAT_FRAME:AddMessage(SliderVar:GetValue() .. " " .. i .. " " .. Smp3_Save.SimpleMp3PlayList[(SliderVar:GetValue() + i) - 1].Name);
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. PlayListDisplay(SliderVar:GetValue() + (i - 1)));
        end
    end
end

-- Playlist update (text show/hide routine)
-- This tells the resizable window how many slots are viewable at that size
function SimpleMp3Playlist_Update()
    if (Smp3_Save.SimpleMp3PlayList[1] == nil) then
        SimpleMp3PlaylistFormPlaylistPanel1:Hide()
        Smp3_Save.VisibleSlots = 0;
    end
    MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);
    local fheight = SimpleMp3PlaylistForm:GetHeight()
    local SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistSlider");

    for i = 1, 25 do
        if (MaxPlayListNum >= i) then
            if ((i * 14) + 37.8 < fheight) then
                x = 'SimpleMp3PlaylistFormPlaylistPanel' .. i .. ':Show()'
                RunScript(x)
                SliderVar:SetMinMaxValues(1, SliderMax(table.getn(Smp3_Save.SimpleMp3PlayList), (i-1)));
                Smp3_Save.VisibleSlots = i;
            else
                x = 'SimpleMp3PlaylistFormPlaylistPanel' .. i .. ':Hide()'
                RunScript(x)
            end
        else
            x = 'SimpleMp3PlaylistFormPlaylistPanel' .. i .. ':Hide()'
            RunScript(x)
            if (MaxPlayListNum == 0) then
                Smp3_Save.VisibleSlots = 0;
            end
        end
    end
    -- Debugging purposes while fixing playlist issues
    -- DEFAULT_CHAT_FRAME:AddMessage(fheight);

    PopulateList()
end

-- Function for when something in the playlist is clicked
function SimpleMp3Playlist_OnClick(MouseButton, Number)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistSlider");

    if (MouseButton == 'LeftButton' and IsControlKeyDown()) then
        if (Smp3_Save.PlaySounds == true) then
            PlaySound("igMiniMapZoomIn");
        end
        tinsert(SimpleMp3PlayListTemp, SliderVar:GetValue() + Number - 1);
    elseif (MouseButton == 'LeftButton' and IsShiftKeyDown()) then
        if (Smp3_Save.isShuffled == true) then
            DEFAULT_CHAT_FRAME:AddMessage(SIMPLEMP3_CANT_REMOVE);
        else
            if (Smp3_Save.PlaySounds == true) then
                PlaySound("igMiniMapZoomIn");
            end
            MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);
            tremove(Smp3_Save.SimpleMp3PlayList, (SliderVar:GetValue() + Number - 1));
            local num = (SliderVar:GetValue() + Number - 1)
            if (num == Smp3_Save.Current) then
                if (Smp3_Save.Current == MaxPlayListNum) then
                    Smp3_Save.Current = 1
                else
                    Smp3_Save.Current = num
                end
                if (isPlaying) then
                    SimpleMp3Form_StopMusic();
                    SimpleMp3Form_StartMusic(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, true); -- FIXME
                else
                    SimpleMp3Form_ResetDisplay(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, true);
                end
            elseif (num < Smp3_Save.Current) then
                Smp3_Save.Current = Smp3_Save.Current - 1
                SimpleMp3Form_ResetDisplay(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, false);
            end
        end
    elseif (MouseButton == 'LeftButton') then
        if (isPlaying == true) then
            SimpleMp3Form_StopMusic();
            Smp3_Save.Current = (SliderVar:GetValue() + Number - 1);
            Smp3_Length = PLInfo('length', Smp3_Save.Current);
            SimpleMp3Form_StartMusic(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, false); -- FIXME
        else
            Smp3_Save.Current = (SliderVar:GetValue() + Number - 1);
            Smp3_Length = PLInfo('length', Smp3_Save.Current);
            SimpleMp3Form_StartMusic(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, true); -- FIXME
        end
    end
end

-- Exit Button
function SimpleMp3Playlist_OnExitClick()
    SimpleMp3PlaylistForm:Hide();
end

-- Playlist scroll function
function SimpleMp3Playlist_OnMouseWheel(Direction)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "PlaylistSlider");

    if (Direction == 1) then
        SliderVar:SetValue(SliderVar:GetValue() - 1);
    else
        SliderVar:SetValue(SliderVar:GetValue() + 1);
    end
end

-- Function to Remove All songs from the PlayList
function RemoveAll_button()
    if (Smp3_Save.isShuffled == false) then
        for i = 1, table.getn(Smp3_Save.SimpleMp3PlayList) do
            tremove(Smp3_Save.SimpleMp3PlayList);
        end
    else
        for i = 1, table.getn(Smp3_Save.SimpleMp3PlayList) do
            tremove(Smp3_Save.SimpleMp3PlayList);
        end
        Smp3_Save.isShuffled = false
        SetShuffleBnText(SIMPLEMP3_BINDSHUFFLEOFF)
        DEFAULT_CHAT_FRAME:AddMessage(SIMPLEMP3_SHUFFLEOFF);
    end
    Smp3_Save.Current = 1
    if (isPlaying) then
        SimpleMp3Form_StopMusic();
    else
        SimpleMp3Form_ResetDisplay(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    end
    SimpleMp3Playlist_Update()
    collectgarbage();
end

-- Function to Remove All Selected songs from the PlayList
function RemoveSelected_button()
    if (SimpleMp3PlayListTemp == nil) then
        return
    end
    if (Smp3_Save.isShuffled == true) then
        DEFAULT_CHAT_FRAME:AddMessage(SIMPLEMP3_CANT_REMOVE);
    else
        for i = 1, table.getn(SimpleMp3PlayListTemp) do
            tsort(SimpleMp3PlayListTemp, 8, 2)
            tremove(Smp3_Save.SimpleMp3PlayList, SimpleMp3PlayListTemp[i]);
            --DEFAULT_CHAT_FRAME:AddMessage(SimpleMp3PlayListTemp[i])
        end
        for i = 1, table.getn(SimpleMp3PlayListTemp) do
            tremove(SimpleMp3PlayListTemp)
        end
        Smp3_Save.Current = 1
        if (isPlaying) then
            SimpleMp3Form_StopMusic();
        else
            SimpleMp3Form_ResetDisplay(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, true);
        end
        SimpleMp3Playlist_Update()
        collectgarbage();
    end
end
